package info.bukova.isspst.services.requirement;

import info.bukova.isspst.Constants;
import info.bukova.isspst.data.Requirement;
import info.bukova.isspst.data.RequirementState;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.transaction.annotation.Transactional;

public class RequirementServiceImpl extends
		RequirementBaseServiceImpl<Requirement> implements RequirementService,
		RequirementBaseService<Requirement> {

	@Autowired
	private RequirementTypeService reqTypeService;

	@Override
	protected Requirement createEntity() {
		Requirement entity = new Requirement();

		entity.setReqDate(new Date());
		entity.setType(reqTypeService.getTypeById(Constants.REQTYPE_ORDER));
		entity.setState(RequirementState.NEW);

		return entity;
	}

	@Override
	@Transactional
	@PreAuthorize("hasPermission(this, 'PERM_ADD')")
	public void add(Requirement entity) {
		entity.setNumser(this.getNumberSerie());
		super.add(entity);
	}
}
